; **** Teeuhr_Elektor_180211.asm ****
; letzter Stand:09.12.2019  -erstellt: Lothar Göde



;-------------- Ports -----------------------------

; Belegung Port A (LCD)
;  Bit 0  =  LCD COM0
;  Bit 1  =  frei
;  Bit 2  =  frei
;  Bit 3  =  frei
;  Bit 4  =  LCD SEG0
;  Bit 5  =  LCD SEG1
;  Bit 6  =  LCD SEG2
;  Bit 7  =  LCD SEG3

; Belegung Port B (Ausgänge)
;  Bit 0  =  frei
;  Bit 1  =  frei
;  Bit 2  =  frei
;  Bit 3  =  frei
;  Bit 4  =  frei
;  Bit 5  =  1= Zugmagnet ein 0= Zugmagnet aus
;  Bit 6  =  frei
;  Bit 7  =  1= Piezo ein 0= Piezo aus

; Belegung Port C (LCD)
;  Bit 0  =  LCD SEG12
;  Bit 1  =  LCD SEG11
;  Bit 2  =  LCD SEG10
;  Bit 3  =  LCD SEG9
;  Bit 4  =  LCD SEG8
;  Bit 5  =  LCD SEG7
;  Bit 6  =  LCD SEG6
;  Bit 7  =  LCD SEG5

; Belegung Port D (LCD)
;  Bit 0  =  LCD SEG22
;  Bit 1  =  LCD SEG21
;  Bit 2  =  LCD SEG20
;  Bit 3  =  LCD SEG19
;  Bit 4  =  LCD SEG18
;  Bit 5  =  LCD SEG17
;  Bit 6  =  LCD SEG16
;  Bit 7  =  LCD SEG15

; Belegung Port E (Eingänge)
;  Bit 0  =  frei
;  Bit 1  =  frei
;  Bit 2  =  frei
;  Bit 3  =  frei
;  Bit 4  =  frei
;  Bit 5  =  Taste +
;  Bit 6  =  Taste -
;  Bit 7  =  frei

; Belegung Port F (JTAG)
;  Bit 0  =  frei
;  Bit 1  =  frei
;  Bit 2  =  frei
;  Bit 3  =  frei
;  Bit 4  =  TCK
;  Bit 5  =  TMS
;  Bit 6  =  TDO
;  Bit 7  =  TDI

; Belegung Port G (LCD)
;  Bit 0  =  LCD SEG14
;  Bit 1  =  LCD SEG13
;  Bit 2  =  LCD SEG4
;  Bit 3  =  LCD SEG24
;  Bit 4  =  LCD SEG23
;  Bit 5  =  frei







.def rlpm		=r0   ;lpm Register immer R0 
.def r_1		=r1   ;Schmierregister
.def r_2		=r2   ;Schmierregister
.def r_3		=r3   ;Schmierregister
.def r_4		=r4   ;Schmierregister
.def r_5		=r5	  ;Schmierregister
.def r_6		=r6   ;Schmierregister
.def r_7		=r7   ;Schmierregister
.def modus_2	=r13  ;Betriebsarten 1.Ebene (Hauptebene)
.def impuls		=r14  ;bit0 = 0,25s Impuls, Bit 1 = 0,5s Impuls, Bit 2 = 1s Impuls, Bit 3 = 2s Impuls 
.def viertelsek	=r15  ;Zeitinterrupt 1/4 Sekundenzähler (0,25s)


.def tmp		=r16 ;Schmierregister
.def tmp1		=r17 ;Schmierregister1
.def tmp2		=r18 ;Schmierregister2
.def tmp3		=r19 ;Schmierregister3
.def scount 	=r20 ;Sekundenzähler 0-59s bei 1Hz
.def modus_1	=r21 ;Betriebsarten 2.Ebene
.def itmp	 	=r22 ;Interrupt Schmierregister
.def sreg1		=r23 ;Statusregister retten
;.def WA        =r24 ;reserviert Wortregister
;.def WA1		=r25 ;reserviert Wortregister
;.def XL		=r26 ;reserviert Wortregister
;.def XH 		=r27 ;reserviert Wortregister
;.def YL		=r28 ;reserviert Wortregister
;.def YH		=r29 ;reserviert Wortregister
;.def ZL		=r30 ;reserviert Wortregister
;.def ZH		=r31 ;reserviert Wortregister


.equ timer2 		=tcnt2	     ;Timerregister
.equ scaler2 		=tccr2a	     ;Scalerregister



.CSEG
.ORG 0x00

;*********************************************************************
;Interrupt-Tabelle (s. Datenblatt ATMega169PA)
;*********************************************************************

; **** Interrupt Vektoren ****

;*** für Reset Bearbeitung (Programmeinsprung)	

   	jmp	RESET		; Routine für Reset Bearbeitung (Programmeinsprung)
	jmp	EXT_INT0	; Routine für externen Interrupt 0 
	jmp	PCINT0_		; Pin Change Interrupt Request 0
	jmp	PCINT1_		; Pin Change Interrupt Request 1
	jmp	TIM2_COMP	; Timer/Counter2 Compare Match
	jmp	TIM2_OVFL	; Timer/Counter2 Overflow
	jmp	TIM1_CAPT	; Timer/Counter1 Capture Event
	jmp TIM1_COMPA	; Timer/Counter1 Compare Match A
	jmp TIM1_COMPB	; Timer/Counter1 Compare Match B
	jmp TIM1_OVF	; Timer/Counter1 Overflow 
	jmp	TIM0_COMP	; Timer/Counter0 Compare Match
	jmp	TIM0_OVF	; Timer/Counter0 Overflow
	jmp	SPI_HANDLE	; SPI Serial Transfer Complete (SPI)
	jmp	UART_RxC	; USART: Rx Complete
	jmp	UART_DRE	; UART: Datenregister leer
	jmp	UART_TxC	; UART, Tx Complete (beendet)
	jmp	USI_START	; USI Start Condition
	jmp	USI_OVFL	; USI Start Overflow
	jmp	ANA_COMP 	; Analog-Comparator
	jmp	AD_CONV		; ADC Conversion Complete
	jmp	EE_RDY		; EEPROM Ready
	jmp	SPM_RDY		; Store Program memory Ready
	jmp	LCD	 		; LCD Start of Frame


	
;---------------------------------------------------------------------

;*********************************************************************
RESET:					;Programmeinsprung	
 
; ***** Stackpointer initialisieren ***** 
 	ldi	tmp, high(ramend) 
	out	sph, tmp
	ldi	tmp, LOW(ramend) 
	out	spl, tmp


;** LCD Initialisierung **
	ldi tmp,0b10000111		;LCD Control und Statusregister B
	sts LCDCRB,tmp	

	ldi tmp,0b00000111		;LCD Frame Rate Register
	sts LCDFRR,tmp

	ldi tmp,0b11100000		;LCD Contrast Control Register
	sts LCDCCR,tmp

	ldi tmp,0b11000000		;LCD Control und Statusregister A
	sts LCDCRA,tmp




;Test, ob alle Segmente funktionieren (kann im Debugg- Mode genutzt werden)   
;	ldi tmp,0b00000001
;	sts LCDDR0,tmp
;	ldi tmp,0b00000010
;	sts LCDDR0,tmp
;	ldi tmp,0b00000100
;	sts LCDDR0,tmp
;	ldi tmp,0b00001000
;	sts LCDDR0,tmp
;	ldi tmp,0b00010000
;	sts LCDDR0,tmp
;	ldi tmp,0b00100000
;	sts LCDDR0,tmp
;	ldi tmp,0b01000000
;	sts LCDDR0,tmp
;	ldi tmp,0b10000000
;	sts LCDDR0,tmp
;	ldi tmp,0b00000000
;	sts LCDDR0,tmp
	
;	ldi tmp,0b00000001
;	sts LCDDR1,tmp
;	ldi tmp,0b00000010
;	sts LCDDR1,tmp
;	ldi tmp,0b00000100
;	sts LCDDR1,tmp
;	ldi tmp,0b00001000
;	sts LCDDR1,tmp
;	ldi tmp,0b00010000
;	sts LCDDR1,tmp
;	ldi tmp,0b00100000
;	sts LCDDR1,tmp
;	ldi tmp,0b01000000
;	sts LCDDR1,tmp
;	ldi tmp,0b10000000
;	sts LCDDR1,tmp
;	ldi tmp,0b00000000
;	sts LCDDR1,tmp

;	ldi tmp,0b00000001
;	sts LCDDR2,tmp
;	ldi tmp,0b00000010
;	sts LCDDR2,tmp
;	ldi tmp,0b00000100
;	sts LCDDR2,tmp
; 	ldi tmp,0b00001000
;	sts LCDDR2,tmp
;	ldi tmp,0b00010000
;	sts LCDDR2,tmp
;	ldi tmp,0b00100000
;	sts LCDDR2,tmp
;	ldi tmp,0b01000000
;	sts LCDDR2,tmp
;	ldi tmp,0b10000000
;	sts LCDDR2,tmp
;	ldi tmp,0b00000000
;	sts LCDDR2,tmp

;	ldi tmp,0b00000001
;	sts LCDDR3,tmp
;	ldi tmp,0b00000000
;	sts LCDDR3,tmp


; alle Segmente löschen
	clr	tmp
	sts LCDDR0,tmp
	sts LCDDR1,tmp
	sts LCDDR2,tmp
	sts LCDDR3,tmp


;** PORTs  initialisieren **

	ser tmp				; Bits setzen  
 	out DDRB,tmp  		; 1=Ausgang
 	clr tmp				; Bits löschen
	out PORTB,tmp 		; Port B sind Ausgänge 

    ldi tmp, 0b00000000
	out DDRE,tmp  		; 1=Ausgang ;0= Eingang
 	ldi tmp, 0b01100000	; Bits setzen (Pull-Up Widerstände einschalten) 
	out PORTE,tmp		; Port E sind Eingänge  



; ***** Interrups einstellen ****
;-------------------------------------------------------------------------------------------------------
;Timer2 voreinstellen 
;-------------------------------------------------------------------------------------------------------

	ldi tmp,0   	     ;Vergleichswert für Uhr (32,768 kHz)-> 30,517µs x 32 (Scaler) x(256) = 0,25s 
	sts timer2,tmp 	     ;timer setzten
	ldi tmp,0b00000011   ;0b001=ohne;0b010=8;0b011=32;0b0101=128 binärer Wert - timer wird gestartet 
	sts scaler2,tmp      ;setze Prescaler auf CLK/128(128-tel vom Takt) 
	lds tmp,timsk2		 ;Timerinterruptmaskenregister einlesen
	ori tmp,0b00000001	 ;Timer2 überlauf erlauben 
	sts timsk2,tmp	     ;Timer Intrrupt erlauben


;-------------------------------------------------------------------------------------------------------		
;	Pin Change Interrupt 	
;-------------------------------------------------------------------------------------------------------

	ldi tmp,0b01100000	 ;1=freigegeben 0= gesperrt (Pin Change Interrupt freigeben für PCINT0 bis PCINT7)
	sts PCMSK0,tmp

	ldi tmp,0b00010000   ;Pin Change Interrupt freigeben für PCINT0 bis PCINT7
	out EIMSK,tmp	     ;in Change Interrupt erlauben	

	sei		         	 ;Freigabe Interrupt


;-------------------------------------------------------------------------------------------------------		
;	Strom sparen 	
;----------------------------------------------------------------------------------------
	lds tmp,PRR				;Powerreduktion 
	sbr tmp,0b0001111		;bit0=ADC;bit1=USATR;bit2=SPI;bit3=Timer1;bit4=LCD
	sts PRR,tmp	

;**** Register initialisieren ****

    clr scount
	clr tmp3
	clr viertelsek
	clr	impuls
	clr	modus_1

	ldi	tmp, 0b00100000	;BA Countdown Timer einstellen
	mov modus_2,tmp

;Variablen im SRAM initialisieren -> Variablen müssen gelöscht werden, da sie nach reset nicht automatisch 
;gelöscht werden
	clr tmp
	sts sekunde,tmp      	 	 	; Sekunde 0-59
	sts minute,tmp       	 	 	; Minute 0-59
	sts stunde,tmp 		  	 	 	; 0-23 bzw. 0-12
  	sts tasten_hist,tmp	   	 	 	; Historie eingelesener Tasten
    sts tastencode,tmp	   	 	 	; tastencode
	sts tastencode_guelt,tmp     	; gültiger Tastencode
	sts tastencodezaehler1L,tmp  	; Tastencodezähler1LOW  (zählt wie oft der gleiche Tastencode eingelesen wurde)  	
	sts tastencodezaehler2L,tmp  	; Tastencodezähler2LOW  (zählt wie oft der gleiche Tastencode eingelesen wurde)  	
    sts imp,tmp					 	; 0,25, 0,5 und 1s Impums aus register Impuls -> impulse bleiben 1 zyklus erhalten
	sts tastencode_guelt_hist,tmp	; History von gültigem Tastencode 
	sts modus_2_hist,tmp   			; Betriebsart Temperatur History
	sts t2_start,tmp    			; nach Reset muss mindestens 1x T2 Interrumpt ausgelöst haben, sonst bleibt die CPU stehen -> erst nach Betätigung einer Taste geht es sonst weiter 
	sts updowncount,tmp			    ; Tastencounter - wenn im Einstellmode zw. steppen und Taste länger betätigt gewechselt wird 
	sts zweitasten,tmp				; Erkennung Zweitastenkombination  
	sts tastencodezaehler3L,tmp  	; Tastencodezähler3LOW (zählt, ob innerhalb von 200ms eine 2. Taste gedrückt wurde)  
	sts tasten200ms,tmp    	        ; Tastenkombination, die nach 200ms erkannt wurde
	sts countdowntimer,tmp    		; Status countdowntimer
	sts timeout_cdstellen,tmp		; Zähler für Timeout Count Down Timer stellen
	sts cd_stunde,tmp   			; Stunde Count Down Timer
	sts cd_modus_2,tmp			    ; Betriebsart retten wenn beim Einstellen des Count Down Timer für Stunde und Minute 0 eingestellt ist 
	sts up_timeout,tmp				; Timeout für Unterprogramm Uhr stellen
	sts up_sekunde,tmp   			; Sekunde 0-59 für Unterprogramm Uhr stellen
	sts up_minute,tmp   			; minute 0-19 für Unterprogramm Uhr stellen
	sts up_modus_1,tmp				; Stunde oder Minute zählen
	sts piezo,tmp   				; Signalgeber
	sts cd_piezo_w,tmp				; Anzahl Wiederholungen für Piezosignal
	sts cd_piezo_z,tmp				; Zeit zwischen den Wiederholungen des Piezosignals

	ldi tmp,4						; Minuten voreinstellen
 	sts cd_minute,tmp   			; Minute Count Down Timer voreinstellen
	ldi tmp,30						; Sekunden voreinstellen
 	sts cd_sekunde,tmp   			; Sekunden Count Down Timer voreinstellen

	ser tmp
	sts sek_01_hist,tmp    			; Sekunde 1-er Stelle History
   	sts sek_10_hist,tmp    			; Sekunde 10-er Stelle History
	sts min_01_hist,tmp  			; Minute 1-er Stelle History
	sts min_10_hist,tmp  			; Minute 10-er Stelle History
	sts tastencode_hist,tmp 		; History von eingelesene und entprellte Tasten








;---------------------------------------------------------------------

;*********************************************************************
;Hauptprogramm
;*********************************************************************
main: 

;Zeitimpulse aus Interrupt umladen		
	
		mov tmp,impuls
		cpi tmp,0  		; nur umladen, wenn im Interrupt bits gesetezt wurden
		brne mai1
		rjmp mai2
mai1: 	mov tmp,impuls  ; bits bleiben im register imp ein Zyklus lang erhalten
		sts imp,tmp
		clr impuls
		rjmp mai2

mai2: 
 nop
.include "tasten.asm"
 nop
.include "countdowntimer.asm"
 nop
.include "uhranzeige.asm"
 nop
.include "piezo.asm"
 nop


;Modus history aktualisieren
		sts modus_2_hist,modus_2			;Betriebsart aktualisieren


;tastencode_guelt_hist beschreiben - muss für einen Zyklus erhalten bleiben
		lds tmp,tastencode_guelt			;tastencode_guelt_hist aktualisieren
		sts tastencode_guelt_hist,tmp

		lds tmp,tastencode					;tastencode_hist aktualisieren 
		sts tastencode_hist,tmp


; Impuls Register löschen		
		mov tmp,impuls
		cpi tmp,0
		breq mai3
		rjmp mai4

mai3:	clr tmp
		sts imp,tmp
		rjmp mai4



mai4:  
; *** Sleep mode vorbereiten **

		in tmp,SMCR
		sbr tmp,0b00000111		;bit0=SE, bit1=SM0, bit2=SM1, bit2=SM2	
		out SMCR,tmp			;sleep Mode Control Register

		lds tmp,t2_start		;nach Reset muss mindestens 1x T2 Interrumpt ausgelöst haben,
		sbrs tmp,0 				;sonst bleibt die CPU stehen -> erst nach Betätigung einer taste (pin change interrupt) 
		rjmp mai9				;geht es dann weiter 


		nop
		sleep					;einschlafen


mai9:	

; da der Uhrenquarz mehr Zeit benötigt zum Anschwingen, wird der erste Timer2 Interrupt 
; mit der Frequenz vom internen Taktgeber gestartet und dann erst das ASSR auf Uhrenquarz umgestellt 
		lds tmp,ASSR		 ;asynchrone Kontrolle
		ori tmp,0b00001000   ;exclk=0(bit4);as2=1 (bit3) asynchrone Betriebsart ext. Quarz
		sts ASSR,tmp		 ;einstellen


		rjmp main





;*** ISR (Interrupts auswerten) ***


EXT_INT0:	; Routine für externen Interrupt 0 		
		reti	
PCINT0_:		; Pin Change Interrupt Request 0
		in sreg1,SREG			; Statusregister retten
	
	
		lds itmp,zweitasten	;Status zweitasten laden
		sbrc itmp,0	   		;überspringe nächsten Befehl wenn bit0 (von 0-7) von zweitasten=0 ->neue Taste erkannt
		rjmp i20_1			;neue Taste erkannt

		push tmp			
		push tmp1			 
		push tmp2			
		push tmp3			


		call tasten


		pop tmp3		
		pop tmp2		
		pop tmp1		
		pop tmp			

i20_1:	out SREG,sreg1   		;Statusregister zurückschreiben
	 	reti
	 	
PCINT1_:			; Pin Change Interrupt Request 1
	reti	
TIM2_COMP:			; Timer/Counter2 Compare Match
	reti	


TIM2_OVFL:					    ; Timer/Counter2 Overflow
		in sreg1,SREG			; Statusregister retten

;		sbic pinb,6 			; Test Ausgang für Zeitinterval
;		rjmp i7_1
;		rjmp i6_1

;i6_1:	sbi PORTB,6			    ;Test
;		rjmp i8_1				;weiter

;i7_1:	cbi PORTB,6				;Test
;		rjmp i8_1				;weiter

;i8_1:	nop


		lds itmp,zweitasten			;Status zweitasten laden
		sbrc itmp,0	   				;überspringe nächsten Befehl wenn bit1 (von 0-7) von zweitasten=1 -> 170ms Zeit für Tastenerkennung läuft
		rjmp i0_1					;Zeit für Tastenerkennung ist abgelaufen
		rjmp i0						;es läuft keine Tastenerkennung

; Tasten nach 170ms einlesen
i0_1:	in itmp,PINE				;Tasten einlesen 
		sts tasten200ms, itmp		;nach 170ms ausgelesene Tasten zum Auswerten abspeichern
        lds itmp,zweitasten   		;170ms sind abgelaufen, es dürfen keine neuen Tastenkombinationen mehr akzeptiert werden 
		sbr itmp,0b00000010	 		;Bit 1 setzen (eine Taste wurde nach 170ms erkannt)
		sts zweitasten,itmp	 		;Status zweitasten abspeichern
		rjmp i0	


i0:		inc viertelsek			; 
		mov itmp,viertelsek
		cpi itmp,4				
		breq i3					;springe wenn gleich 4= (1,0s)
		rjmp i2

i3: 	clr viertelsek
		mov itmp,impuls
		sbr itmp,0b00000111 	;setzte bit 0 im Register impuls (1s) 
		mov impuls,itmp
	
; **** Uhr  ****		
; Sekunden zählen		
		inc scount				;alle 1s Sekundenregister erhöhen 
 	    cpi scount,60
		breq i1					;springe wenn gleich 
		rjmp i2
i1: 	ldi scount,0			;Sekunden löschen
; Minuten zählen
		lds itmp,minute
		inc itmp
		cpi itmp,60				;Minute =60 ? 
		breq i14	
		rjmp i15

; Stunden zählen
i14:	ldi itmp,0
		sts minute,itmp			;Minutenwert im SRAM ablege
		lds itmp,stunde
		inc itmp 
		cpi itmp,24				;Stunde =24 ? 
		breq i16
		sts stunde,itmp			;Stundenwert im SRAM ablege
		rjmp i2

i16:	ldi itmp,0
		sts stunde,itmp			;Stundenwert im SRAM ablege
		rjmp i2

i15:    sts minute,itmp			;Minutenwert im SRAM ablege
	    rjmp i2

i2: 	mov itmp,scount			;0-59s aus Zeitinterrupt 
		sts sekunde,itmp		;Sekundenwert im SRAM ablegen
;Impuls 0,25s erzeugen
		mov itmp,impuls
		sbr itmp,0b00000001 	;setzte bit 0 im Register impuls (0,25s) 
		mov impuls,itmp
		mov itmp,viertelsek		; Impulse erzeugen
		cpi itmp,2				;0,5s
		breq i4	
		rjmp i5
;Impuls 0,5s erzeugen
i4: 	mov itmp,impuls
		sbr itmp,0b00000010 	;setzte bit 1 im Register impuls (0,5s) 
		mov impuls,itmp

i5:		ldi itmp,0b00000001		;nach Reset muss mindestens 1x T2 Interrupt ausgelöst 
		sts t2_start,itmp		;haben, sonst bleibt die CPU stehen -> erst nach Betätigung einer Taste geht es sonst weiter 

		lds itmp,countdowntimer
 		sbrc itmp,5	         	;überspringe nächsten Befehl wenn bit5 (von 0-7) von countdowntimer =0 ->Count Down Timer abgelaufen und Bit 5 Hubmagnet ein 
		rjmp i6					;PB5 setzen -> Hubmagnet ein
		rjmp i7					;PB5 löschen -> Hubmagnet aus

i6:		sbi PORTB,5				;Hubmagnet einschalten Teebeutel kann raus
		rjmp i8					;weiter

i7:		cbi PORTB,5				;Hubmagnet nach 250ms ausschalten 
		rjmp i8					;weiter


i8:		out SREG,sreg1   		;Statusregister zurückschreiben
		reti	




TIM1_CAPT:	; Timer/Counter1 Capture Event
		reti	
TIM1_COMPA: ; Timer/Counter1 Compare Match A
        reti	
TIM1_COMPB: ; Timer/Counter1 Compare Match B
		reti	
TIM1_OVF:	; Timer/Counter1 Overflow 
		reti	
TIM0_COMP:	; Timer/Counter0 Compare Match
		reti	
TIM0_OVF:	; Timer/Counter0 Overflow
		reti
SPI_HANDLE:	; SPI Serial Transfer Complete (SPI)
		reti		
UART_RxC:	; USART: Rx Complete
		reti	
UART_DRE:	; UART: Datenregister leer
		reti		
UART_TxC:	; UART, Tx Complete (beendet)
		reti	
USI_START:	; USI Start Condition
		reti	
USI_OVFL:	; USI Start Overflow
		reti		
ANA_COMP:	; Analog-Comparator
		reti	
AD_CONV:	; ADC Conversion Complete
		reti		
EE_RDY:		; EEPROM Ready
		reti	
SPM_RDY:	; Store Program memory Ready
		reti		
LCD: 		; LCD Start of Frame
		reti


; Konstanten ------  immer nach den Befehlen !!!!!!! 
; Segmente für Uhr LCD Anzeige in der Reihenfolge LCDDR0, LCDDR1, LCDDR2,LCDDR3 (linke Spalte beginnt mit LCDDR3)

; Uhr - Daten 1-er Stelle Sekunden
uhr_xx_x0: .db 0b00111111, 0b00000000, 0b00000000, 0b00000000 ;
uhr_xx_x1: .db 0b00000110, 0b00000000, 0b00000000, 0b00000000 ;
uhr_xx_x2: .db 0b01011011, 0b00000000, 0b00000000, 0b00000000 ;
uhr_xx_x3: .db 0b01001111, 0b00000000, 0b00000000, 0b00000000 ;
uhr_xx_x4: .db 0b01100110, 0b00000000, 0b00000000, 0b00000000 ;
uhr_xx_x5: .db 0b01101101, 0b00000000, 0b00000000, 0b00000000 ;
uhr_xx_x6: .db 0b01111101, 0b00000000, 0b00000000, 0b00000000 ;
uhr_xx_x7: .db 0b00100111, 0b00000000, 0b00000000, 0b00000000 ;
uhr_xx_x8: .db 0b01111111, 0b00000000, 0b00000000, 0b00000000 ;
uhr_xx_x9: .db 0b01101111, 0b00000000, 0b00000000, 0b00000000 ;
uhr_xx_xa: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ;a
uhr_xx_xb: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ;	;b
uhr_xx_xc: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ;	;c
uhr_xx_xd: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ;	;d
uhr_xx_xe: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ;	;e
uhr_xx_xf: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ;f
uhr_xx_xh: .db 0b01000000, 0b00000000, 0b00000000, 0b00000000 ; ;"-"
uhr_xx_xg: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ; einer Stelle Sekunden aus

; Uhr - Daten 10-er Stelle Sekunden
uhr_xx_0x: .db 0b00000000, 0b00111111, 0b00000000, 0b00000000 ;
uhr_xx_1x: .db 0b00000000, 0b00000110, 0b00000000, 0b00000000 ;
uhr_xx_2x: .db 0b00000000, 0b01011011, 0b00000000, 0b00000000 ;
uhr_xx_3x: .db 0b00000000, 0b01001111, 0b00000000, 0b00000000 ;
uhr_xx_4x: .db 0b00000000, 0b01100110, 0b00000000, 0b00000000 ;
uhr_xx_5x: .db 0b00000000, 0b01101101, 0b00000000, 0b00000000 ;
uhr_xx_6x: .db 0b00000000, 0b01111101, 0b00000000, 0b00000000 ;
uhr_xx_7x: .db 0b00000000, 0b00100111, 0b00000000, 0b00000000 ;
uhr_xx_8x: .db 0b00000000, 0b01111111, 0b00000000, 0b00000000 ;
uhr_xx_9x: .db 0b00000000, 0b01101111, 0b00000000, 0b00000000 ;
uhr_xx_ax: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ;a
uhr_xx_bx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ;b
uhr_xx_cx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ;c
uhr_xx_dx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ;d
uhr_xx_ex: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ;e
uhr_xx_fx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ;f
uhr_xx_hx: .db 0b00000000, 0b01000000, 0b00000000, 0b00000000 ; ;"-"
uhr_xx_gx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ; zehner Stelle Sekunden aus

; Uhr - Daten 1-er Stelle Minuten
uhr_x0_xx: .db 0b00000000, 0b00000000, 0b00111111, 0b00000000 ;
uhr_x1_xx: .db 0b00000000, 0b00000000, 0b00000110, 0b00000000 ;
uhr_x2_xx: .db 0b00000000, 0b00000000, 0b01011011, 0b00000000 ;
uhr_x3_xx: .db 0b00000000, 0b00000000, 0b01001111, 0b00000000 ;
uhr_x4_xx: .db 0b00000000, 0b00000000, 0b01100110, 0b00000000 ;
uhr_x5_xx: .db 0b00000000, 0b00000000, 0b01101101, 0b00000000 ;
uhr_x6_xx: .db 0b00000000, 0b00000000, 0b01111101, 0b00000000 ;
uhr_x7_xx: .db 0b00000000, 0b00000000, 0b00100111, 0b00000000 ;
uhr_x8_xx: .db 0b00000000, 0b00000000, 0b01111111, 0b00000000 ;
uhr_x9_xx: .db 0b00000000, 0b00000000, 0b01101111, 0b00000000 ;
uhr_xa_xx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ;a
uhr_xb_xx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ;b
uhr_xc_xx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ;c
uhr_xd_xx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ;d
uhr_xe_xx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ;e
uhr_xf_xx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ;f
uhr_xh_xx: .db 0b00000000, 0b00000000, 0b01000000, 0b00000000 ; ;"-"
uhr_xg_xx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ; einer Stelle Minuten aus

; Uhr - Daten 10-er Stelle Minuten
uhr_0x_xx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ;
uhr_1x_xx: .db 0b10000000, 0b10000000, 0b00000000, 0b00000000 ;
uhr_2x_xx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ;
uhr_3x_xx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ;
uhr_4x_xx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ;
uhr_5x_xx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ;
uhr_6x_xx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ;
uhr_7x_xx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ;
uhr_8x_xx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ;
uhr_9x_xx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ;
uhr_ax_xx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ;a
uhr_bx_xx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ;b
uhr_cx_xx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ;c
uhr_dx_xx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ;d
uhr_ex_xx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ;e
uhr_fx_xx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ;f
uhr_hx_xx: .db 0b00000000, 0b00000000, 0b10000000, 0b00000000 ; ;"-"
uhr_gx_xx: .db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; ; einer Stelle Minuten aus





















.DSEG 								   ; das Folgende kommt ins SRAM
.ORG 0x0100                   	 	   ; gem. Datenblatt ab Adresse 0x0100 verfügbar    

; SRAM Variablen  
sekunde: 				.BYTE   1      ; 1 Sekunde 0-59
minute:   				.BYTE   1      ; 2 Minute 0-59
stunde:     			.BYTE   1	   ; 3 Stunde 0-23
sek_01_hist:			.BYTE   1	   ; 4 Sekunde 1-er Stelle History
sek_10_hist:   			.BYTE   1	   ; 5 Sekunde 10-er Stelle History
min_01_hist: 			.BYTE   1	   ; 6 Minute 1-er Stelle History
min_10_hist: 			.BYTE   1	   ; 7 Minute 10-er Stelle History
tasten_hist:   			.BYTE   1	   ; 8 history eingelesene Tasten	
tastencode:    			.BYTE   1	   ; 9 eingelesene und entprellte Tasten
tastencode_hist:		.BYTE   1	   ; 10 History von eingelesene und entprellte Tasten
tastencode_guelt:  		.BYTE   1	   ; 11 gültiger Tastencode
tastencodezaehler1L:    .BYTE   1	   ; 12 Tastencodezähler1LOW  (zählt wie oft der gleiche Tastencode eingelesen wurde)  	
tastencodezaehler2L:    .BYTE   1	   ; 13 Tastencodezähler2LOW  (zählt wie oft der gleiche Tastencode eingelesen wurde)  	
imp:    				.BYTE   1	   ; 14 0,25, 0,5 und 1s Impuls aus register Impuls -> impulse bleiben 1 zyklus erhalten
tastencode_guelt_hist:	.BYTE   1	   ; 15 History von gültigem Tastencode 
modus_2_hist:  			.BYTE   1	   ; 16 Betriebsart Temperatur History
t2_start:    			.BYTE   1	   ; 17 nach Reset muss mindestens 1x T2 Interrumpt ausgelöst haben, sonst bleibt die CPU stehen -> erst nach Betätigung einer taste geht es dann weiter 
updowncount:			.BYTE   1	   ; 18 Tastencounter - wenn im Einstellmode zw. steppen und Taste länger betätigt gewechselt wird 
zweitasten:				.BYTE   1	   ; 19 Erkennung Zweitastenkombination innerhalb 200ms
tastencodezaehler3L:	.BYTE   1	   ; 20 Tastencodezähler3LOW (zählt, ob innerhalb von 200ms eine 2. Taste gedrückt wurde)  
tasten200ms:    		.BYTE   1	   ; 21 Tastenkombination, die nach 200ms erkannt wurde
countdowntimer:    		.BYTE   1	   ; 22 Status countdowntimer
timeout_cdstellen:		.BYTE   1	   ; 23 Zähler für Timeout Count Down Timer stellen
cd_minute:   			.BYTE   1      ; 24 Minute Count Down Timer
cd_stunde:     			.BYTE   1	   ; 25 Stunde Count Down Timer
cd_sekunde:    			.BYTE   1	   ; 26 Sekunde Count Down Timer
cd_modus_2:				.BYTE   1	   ; 27 Betriebsart retten
up_timeout:    			.BYTE   1	   ; 28 Timeout für Unterprogramm Uhr stellen
up_sekunde:   			.BYTE   1      ; 29 Sekunde 0-59 für Unterprogramm Uhr stellen
up_minute:     			.BYTE   1	   ; 30 Minute 0-19 für Unterprogramm Uhr stellen
up_modus_1:				.BYTE   1	   ; 31 Stunde oder Minute zählen
piezo:    				.BYTE   1	   ; 32 Signalgeber
cd_piezo_w:				.BYTE   1	   ; 33 Anzahl Wiederholungen für Piezosignal
cd_piezo_z:				.BYTE   1	   ; 34 Zeit zwischen den Wiederholungen des Piezosignals
















