; **** tasten.asm ****
; letzter Stand :25.01.2014  -erstellt: Lothar Gde


;- einlesen der Tastatur 
;- Tasten entprellen
;- Tastaturcodes zusammenstellen

; tasten_hist = vom Port eingelesene Tasten (negiert) vom Vorzyklus   
; tastencode  = aktueller Tastencode ermittelt z.B. 0x04 fr Taste +; 0x08 fr Taste - 0x0C fr Taste + und Taste -, 0x00 fr keine Taste bettigt
; tastencode_hist = Tastencode vom Vorzyklus
; tastencodezaehler3L = aktuellen Wert von Timer2 bei Start der Zeit
; tasten200ms = Taste, die nach 170ms erkannt wurde


		cli
		lds tmp,zweitasten	;Status zweitasten laden
		sbrc tmp,1	   		;berspringe nchsten Befehl wenn bit0 (von 0-7) von zweitasten=1 -> 170ms Zeit fr Tastenerkennung sind abgelaufen
		rjmp ta40			;170ms Zeit fr Tastenerkennung sind abgelaufen
		rjmp ta99_2
ta40:   lds tmp,tasten200ms	;ausgelesene Tasten nach 170ms
		rcall tasten
		rjmp ta99_2


; *** Unterprogramm Tasten ***
tasten:	lds tmp1,zweitasten	;Status zweitasten laden
		sbrc tmp1,2	   		;berspringe nchsten Befehl wenn bit1 (von 0-7) von zweitasten=1 -> 170ms Zeit fr Tastenerkennung sind abgelaufen und Tasten ist noch gedrckt
		rjmp ta8_3			;alles lschen
		
		sbrc tmp1,1	   		;berspringe nchsten Befehl wenn bit1 (von 0-7) von zweitasten=1 -> 170ms Zeit fr Tastenerkennung sind abgelaufen
		rjmp ta41_1			;200ms Zweitastenerkennung abgelaufen
		sbrc tmp1,0	   		;berspringe nchsten Befehl wenn bit0 (von 0-7) von zweitasten=0 ->Zweitastenerkennung aktiv
		rjmp ta41_1			;170ms Timer zhlen
		rjmp ta41			;keine Zweitastenerkennung aktiv -> ohne 200ms Timer



;***** _________________________*****
; Tasten einlesen 
ta41:	in tmp,PINE				;Tasten einlesen PE4-7 belegt
		
ta41_1:	ori tmp,0b10010000  	;Tasten PE7 und PE4 sind nicht vorhanden (Reserve)
		lsr tmp					;4x nach rechts schieben,damit bit0 bis bit 3 belegt werden
		lsr tmp
		lsr tmp
		lsr tmp
;--------------------------------------------------------------------
;Auswertung  der Tastenkombination
ta1: 	sec					 ; Carry auf 1 setzen 
		rol tmp				 ; 1x links schieben mit Carry, damit Code vom alten Sender bereinstimmt 
		com	tmp				 ; ergebnis negieren 
		andi tmp,0b00011111	 ; nach negieren sind obere bits 1 , deshalb obere 3 bits ausblenden
		sts tastencode,tmp   ; 

		lds tmp1,zweitasten	 ;Status zweitasten laden
		sbrc tmp1,0	   		 ;berspringe nchsten Befehl wenn bit0 (von 0-7) von zweitasten=1 -> 
		rjmp ta2_3			 ;Timer 170ms abgelaufen
		rjmp ta8_2			 ;neue Taste erkannt - Timer 170ms starten

ta2_3:  lds tmp,zweitasten   ;200ms sind abgelaufen, es drfen keine neuen Tastenkombinationen mehr akzeptiert werden 
		cbr tmp,0b00000011	 ;Bit 0 und Bit 1 lschen (eine Taste wurde erkannt - eine 2. Taste wird nicht mehr akzeptiert)
		sbr tmp,0b00000100	 ;Bit 2 setzen (170ms Zeit ist abgelaufen, aber Taste ist noch gedrckt)
		sts zweitasten,tmp	 ;Status zweitasten abspeichern

		lds tmp,tastencode		
		cpi tmp,0x04			;Tastencode fr Taste +
		breq ta10				;Tastaturcode als gltig eintragen
		cpi tmp,0x08			;Tastencode fr Taste -
		breq ta10				;Zastaturcode als gltig eintragen
		cpi tmp,0x0C			;Tasten Taste + und Taste - bettigt (Uhr stellen oder weiter)
		breq ta10				;Tastaturcode als gltig eintragen
		rjmp ta8_1				;keine Taste bettigt

ta8_3:  clr tmp					;keine Taste bettigt					
		rjmp ta8_1


; Start Zeit fr neu erkannte Taste
ta8_2:	sbr tmp1,0b00000001		;Bit 0 setzen (eine Taste wurde erkannt - eine 2. Taste darf innerhalb 200ms dazukommen)		)
		sts zweitasten,tmp1
		ldi tmp1, 85			;Startwert fr tcnt2 255-170=85
		sts tcnt2,tmp1
		rjmp ta99				;Sprung zum Ende

ta8_1:  clr tmp1				;tmp1 lschen
		sts zweitasten,tmp1		;Status zweitasten lschen
		sts tasten200ms,tmp1
		rjmp ta10				;Sprung zu Tastencode gltig


; *** Tastaturcode als gltig bernehmen ****
ta10:	sts tastencode_guelt,tmp	  ;tastencode als gltig bernehmen
		rjmp ta99

ta99:  	nop		;Ende Up
		ret
; *** Ende Unterprogramm Tasten ***


ta99_2: sei
		nop     ;Ende

				















